﻿Option Strict On

Imports Microsoft.Kinect
Class MainWindow
    Dim kinect As KinectSensor
    Const maxDepthValue As Integer = 2000
    Dim myDepthPixelData As Short()
    Dim myColorPixelData As Byte()
    Dim myImageRect As Int32Rect

    Property Person As WriteableBitmap
 

   


    Private Sub MainWindow_Loaded(sender As Object, e As System.Windows.RoutedEventArgs) Handles Me.Loaded
        If KinectSensor.KinectSensors.Count = 0 Then
            MessageBox.Show("KINECTが接続されておりません。")
            Exit Sub
        Else
            kinect = KinectSensor.KinectSensors(0)
            kinect.DepthStream.Enable(DepthImageFormat.Resolution640x480Fps30)
            kinect.ColorStream.Enable(ColorImageFormat.RgbResolution640x480Fps30)
            kinect.SkeletonStream.Enable()

            Dim myDepthStream As DepthImageStream = kinect.DepthStream
            Dim myColorStream As ColorImageStream = kinect.ColorStream
            myDepthPixelData = New Short(myDepthStream.FramePixelDataLength - 1) {}
            myColorPixelData = New Byte(myColorStream.FramePixelDataLength - 1) {}

            Person = New WriteableBitmap(myDepthStream.FrameWidth, myDepthStream.FrameHeight, 96, 96, PixelFormats.Bgra32, Nothing)
            myImageRect = New Int32Rect(0, 0, CInt(Math.Ceiling(Person.Width)), CInt(Math.Ceiling(Person.Height)))
            kinect.Start()
            AddHandler CompositionTarget.Rendering, Sub(renderSender As Object, renderArgs As EventArgs)
                                                        Using colorFrame As ColorImageFrame = kinect.ColorStream.OpenNextFrame(100)
                                                            Using depthFrame As DepthImageFrame = kinect.DepthStream.OpenNextFrame(100)
                                                                AppearPlayer(colorFrame, depthFrame)
                                                            End Using
                                                        End Using
                                                    End Sub
            DataContext = Me 'この記述がないと人物が表示されない。MainWindow自身のインスタンスを渡す
        End If
    End Sub

    Private Sub AppearPlayer(colorFrame As ColorImageFrame, depthFrame As DepthImageFrame)
        If kinect Is Nothing = True OrElse depthFrame Is Nothing = True OrElse colorFrame Is Nothing = True Then
            Return
        End If

        Dim playerDepth As Integer = 0

        Dim myDepthPixelIndex As Integer = 0
        Dim myPlayerIndex As Integer = 0
        Dim myColorPixelIndex As Integer = 0


        Dim myColorStride As Integer = colorFrame.BytesPerPixel * colorFrame.Width
        Dim myScreenImageStride As Integer = kinect.DepthStream.FrameWidth * colorFrame.BytesPerPixel

        Dim myImageIndex As Integer = 0

        Dim bytePlayer As Byte() = New Byte(depthFrame.Height * myScreenImageStride - 1) {}
        depthFrame.CopyPixelDataTo(myDepthPixelData)
        colorFrame.CopyPixelDataTo(myColorPixelData)

        For depthFrameData As Integer = 0 To depthFrame.Height - 1
            Dim depthData As Integer = 0
            While depthData < depthFrame.Width
                myDepthPixelIndex = depthData + (depthFrameData * depthFrame.Width)
                myPlayerIndex = myDepthPixelData(myDepthPixelIndex) And DepthImageFrame.PlayerIndexBitmask
                Dim myColorPoint As ColorImagePoint = kinect.MapDepthToColorImagePoint(depthFrame.Format, depthData, depthFrameData, myDepthPixelData(myDepthPixelIndex), colorFrame.Format)
                myColorPixelIndex = (myColorPoint.X * colorFrame.BytesPerPixel) + (myColorPoint.Y * myColorStride)
                If myPlayerIndex <> 0 Then
                    playerDepth = myDepthPixelData(myDepthPixelIndex) >> DepthImageFrame.PlayerIndexBitmaskWidth

                    If playerDepth < maxDepthValue Then
                        bytePlayer(myImageIndex) = myColorPixelData(myColorPixelIndex)
                        bytePlayer(myImageIndex + 1) = myColorPixelData(myColorPixelIndex + 1)
                        bytePlayer(myImageIndex + 2) = myColorPixelData(myColorPixelIndex + 2)
                        bytePlayer(myImageIndex + 3) = &HFF
                    End If
                End If
                depthData = depthData + 1
                myImageIndex = myImageIndex + colorFrame.BytesPerPixel
            End While
        Next

        Person.WritePixels(myImageRect, bytePlayer, myScreenImageStride, 0)
        TextBlock1.Text = String.Format("深度={0}", playerDepth)
    End Sub

    Private Sub MainWindow_Closing(sender As Object, e As System.ComponentModel.CancelEventArgs) Handles Me.Closing
        If kinect Is Nothing = False Then
            If kinect.IsRunning = True Then
                kinect.Stop()
                kinect.Dispose()
            End If
        End If

    End Sub
End Class
